;--TEST FTOC: (treballant-hi!!!!)
;--        Es prepara ftoc per treballar amb CMPS03
;--        Interrupci per FTOC
;--        Davant dada ftoc s'envien 8 bits mensys significatius a leds
;--            ...i es fa tractament per enviar prescaler i ftoc a set-segments
.ORG 0;
	RJMP main;		(+31)
	NOP;
	NOP;
	RJMP isrExt1dw;	 	--(+268) 	->a 272
	NOP;
.ORG 11;
	RJMP error1;	 	--(+513)     ->a error (525)
	RJMP isrFTOC1;	 	--(+387)	->a 400
	RJMP isrFTOC0;	 	--(+370)	->a 384
	NOP;
	NOP;
	RJMP error2;	 	--(+513)     ->a error (530)

.ORG 32;
main: LDI X, 1024;		--Inicialitzar set-segments
	LPM R16, X;
	OUT SS0, R16;
	OUT SS1, R16;
	OUT SS2, R16;
	OUT SS3, R16;
	LDI R16, 0x0004;	--Inicialitzaci interrupc. extern.
	OUT ext0ctrl, R16;
	LDI R16, 0xA7D;		--R16: variable temp
	OUT FTOC0CTRL, R16; 	--Inicialitzaci ADDRCTRL_FTOC0
	OUT FTOC1CTRL, R16; 	--Inicialitzaci ADDRCTRL_FTOC1
;--Activaci interrupts
	SEI;			--(BSET 0x7)
retorn: LDI R2, 0x0;		--R2: controla si nova dada
test: CPI R2, 0x000;
	BRZE test;		-- (-3)
	MOV R0, Z;      	--Mentre tractament, si varia Z, no ho fa R0              
	RCALL tractarR2;	--10 (a 64)
	RJMP retorn;		--(-8)
	NOP;
	NOP;

;--Rutina de tractament
;--Primer s'envia pols per visualitzar interrupci en ftoc (per port XX)
;--R0 mant valor ftoc, R1 es fa servir per treballar
.ORG 64;
tractarR2: MOV R1, R0;
	ANDI R1, 0x7FF;
	OUT PORTB, R1;              
	ORI R1, 0x800;		--Enviar a leds i 0 int.
	OUT PORTB, R1;               
	ANDI R1, 0x7FF;		--Enviar a leds i 1 int.
	OUT PORTB, R1;              
--Enviar a leds i 0 int. Desprs s'envia dada ftoc a set-segments
	MOV X, R0;		--Dada ss0
	ANDI X, 0x00F;
	ADDI X, 1024;		--Cerca valor ss0
	LPM R1, X;
	OUT SS0, R1;
	LSR R0;			--Dada ss1
	LSR R0;
	LSR R0;
	LSR R0;
	MOV X, R0;
	ANDI X, 0x00F;
	ADDI X, 1024;		--Cerca valor ss1
	LPM R1, X;
	OUT SS1, R1;
	LSR R0;			--Dada ss2
	LSR R0;
	LSR R0;
	LSR R0;
	MOV X, R0;
	ANDI X, 0x00F;
	ADDI X, 1024;		--Cerca valor ss2
	LPM R1, X;
	OUT SS2, R1;
	RET;
	NOP;

;----Rutina d'interrupci isrExt1down (polsador de prova: envia slides a leds)
.ORG 272;
isrExt1dw: IN Z, PORTA;		--Agafar slides
	OUT PORTB, Z;		--Enviar a leds
	LDI R2, 0x001;
	RETI;
	NOP;
--Rutina d'interrupci isrFTOC0----------------------------------
.ORG 384;
isrFTOC0: IN Z, FTOC0;		--S'agafa dada de ftoc
	LDI R2, 0x001;		--R2=1 => Nova dada !!
	RETI;
	NOP;
--Rutina d'interrupci isrFTOC1----------------------------------
.ORG 400;
isrFTOC1: IN Z, FTOC1;		--S'agafa dada de ftoc
	LDI R2, 0x001;		--R2=1 => Nova dada !!
	RETI;
	NOP;
;--Rutina d'interrupci d'error 1---------------------------------
.ORG 525;
error1: LDI X, 1025;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
;--Rutina d'interrupci d'error 2---------------------------------
.ORG 530;
error2: LDI X, 1025;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;
;-----------------------------------------------------------------
.org 1024;	; codis set-segments
.dw 0x3F, 0x6, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x7, 0x7F;
.dw 0x67, 0x5F, 0x7C, 0x58, 0x5E, 0x79, 0x71, 0x80;
